<?php

$status = array
(
    1 => '待支付',
    2 => '待处理',
    3 => '处理中',
    4 => '待收货确认',
    5 => '已完成',
    6 => '已完成（有退款）',
    7 => '已取消',
    8 => '已退款',
    11 => '已过期',
);

$audit = array
(
    //1 => '待审核',
    2 => '审核通过',
    3 => '审核未通过',
);

return array
(
    # 表名
    'name' => 'buy',
    # 显示给用户看的名称
    'lang' => '订货订单',
    'order' => 99,
    'set' => array
    (
    	'status' => $status,
    ),

    # 数据结构
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            //'list'      => true,
        ),

        'order_num'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '订单号',
            'default'   => '',
            'desc'      => '订单号',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list_name'	=> '订单信息',
            'list'      => 'Dever::load("scm_order/lib/buy.info#order", {id})',
        ),

        'seller_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '销售商',
            'default'   => '',
            'desc'      => '销售商',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'search'    => array
            (
                'api' => 'scm_role/seller-like',
                'col' => 'name',
                'result' => 'id',
            ),
            'value'     => Dever::input('search_option_seller_id'),
        ),

        'address'      => array
        (
            'type'      => 'varchar-2000',
            'name'      => '收货信息',
            'default'   => '',
            'desc'      => '收货信息',
            'match'     => 'is_numeric',
            'search'	=> 'fulltext',
            'list'      => 'Dever::load("scm_order/lib/sell.info#address", {id})',
        ),

        'num'        => array
        (
            'type'      => 'int-11',
            'name'      => '购买总数量',
            'default'   => '',
            'desc'      => '购买总数量',
            'match'     => 'is_numeric',
            'list_name'	=> '金额信息',
            'list'      => 'Dever::load("scm_order/lib/sell.info#cash", {id})',
        ),

        'cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '订单总金额',
            'default'   => '0',
            'desc'      => '订单总金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'pay_cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '支付金额',
            'default'   => '0',
            'desc'      => '支付金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'wallet_cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '钱包抵扣金额',
            'default'   => '0',
            'desc'      => '钱包抵扣金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'score'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '订单总积分',
            'default'   => '0',
            'desc'      => '订单总积分',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'info'      => array
        (
            'type'      => 'varchar-300',
            'name'      => '订单备注',
            'default'   => '',
            'desc'      => '订单备注',
            'match'     => 'option',
            'update'    => 'textarea',
        ),

        'status'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '订单状态',
            'default'   => '1',
            'desc'      => '订单状态',
            'match'     => 'is_numeric',
            'option'    => $status,
            'search'    => 'select',
            //'search_after' => '<br />',
            //'mul'   => true,
            //'mul_option' => array(2 => '批量审核', 5 => '确认收货'),
        ),

        'audit'        => array
	    (
	        'type'      => 'tinyint-1',
	        'name'      => '审核状态',
	        'default'   => '1',
	        'desc'      => '审核状态',
	        'match'     => 'is_numeric',
	        'option'    => $audit,
	        //'search'    => 'select',
	        'update'    => 'radio',
	    ),

	    'audit_desc'        => array
	    (
	        'type'      => 'varchar-500',
	        'name'      => '审核备注',
	        'default'   => '',
	        'desc'      => '审核备注',
	        'match'     => 'option',
	        'update'    => 'textarea',
	    ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '下单时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'sdate',
            'list'        => 'date("Y-m-d H:i", {cdate})',
        ),
    ),

    'manage' => array
    (
        'delete' => false,
        'edit' => false,
        'insert' => false,
        //'excel' => $excel,
        //'mul' => $mul,

        'button' => array
        (
            //'导出订单明细' => array('excel', 'shop/excel.sell_order'),
        ),

        'list_button' => array
        (
            //fast_list
            /*
            'list' => array('查看详情', '"sell_order_goods&project=shop&order_id={id}&page_type=&search_option_shop_type='.$search_option_shop_type.'"'),

            'list11' => array('查看采购单', '"buy_order&project=shop&search_option_type=1&&search_option_parent_type=2&search_option_parent_order_id={id}&oper_table=sell_order&search_option_shop_type='.$search_option_shop_type.'"', '{status} >= 3 && {audit} == 2 && {shop_type} == 2'),

            'list1' => array('审核', '"sell_order_goods&project=shop&order_id={id}&audit=1&page_type=&search_option_shop_type='.$search_option_shop_type.'"', '{status} == 2 && {shop_type} == 2'),

            'oper'  => array('确认收货', '"shop/lib/manage.setSellOrderStatus?shop_id={shop_id}&order_id={id}"', '{status} == 4 && {shop_type} == 2'),
            */
        ),
    ),

    'request' => array
    (
        'getList' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'shop_id' => 'yes',
                'uid' => 'yes',
                'status' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'page' => array(5, 'list'),
            'col' => '*',
        ),

        'getAll' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'uid' => 'yes',
                'name' => array('yes', 'like'),
                'shop_id' => 'yes',
                'mobile' => 'yes',
                'method' => 'yes',
                'pay_method' => 'yes',
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*',
        ),
    ),
);
