<?php

return array
(
    # 表名
    'name' => 'servicer_store_goods',
    # 显示给用户看的名称
    'lang' => '仓库商品列表',
    'order' => 10,
    'menu'  => false,

    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            //'list'        => true,
        ),

        'servicer_store_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '所属配送商',
            'default'   => '',
            'desc'      => '所属配送商',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'search'    => 'hidden',
            'value'     => Dever::input('search_option_servicer_store_id'),
            'list'      => 'Dever::load("scm_role/servicer_store-one#name", {servicer_store_id})',
        ),

        'goods_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '商品名称',
            'default'   => '',
            'desc'      => '商品名称',
            'match'     => 'is_numeric',
            'update'    => 'select',
            'update_search' => 'scm_product/lib/manage.search',
            'list'      => 'Dever::load("scm_product/info-one#name", {goods_id})',
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'date',
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        'insert' => false,
        'edit' => false,
        'delete' => false,
    ),

    'request' => array
    (
        'getData' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'seller_id' => array('yes-t_1.seller_id'),
                'sell_type' => array('yes-t_2.sell_type'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'scm_product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'col' => 'id,name,category,pic,content,video,type,unit,spec_type,goods,commission,pay_money,money_id,score_id,sell_type,buy_type,udate,cdate',
        ),

        'getDataPage' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'seller_id' => array('yes-t_1.seller_id'),
                'sell_type' => array('yes-t_2.sell_type'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'scm_product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => 'id,name,category,pic,content,video,type,unit,spec_type,goods,commission,pay_money,money_id,score_id,sell_type,buy_type,udate,t_1.cdate,t_1.id as id',
        ),
    ),
);
