<?php

$type = function()
{
	$array = array();
	$data = Dever::load('scm_seller/type-state');
	if($data)
	{
		$array += $data;
	}
	return $array;
};

$category = function()
{
	$array = array();
	$data = Dever::load('scm_product/category-getTop');
	if($data)
	{
		$array += $data;
	}
	return $array;
};

$price = function()
{
    $array = array
    (
        -1 => '默认模板',
    );
    $data = Dever::load('scm_product/price-state');
    if($data)
    {
        $array += $data;
    }
    return $array;
};

$func = array
(
    'base' => '基础运营',
    'news' => '文章资讯',
    'agent' => '分销代理',
	'product' => '平台商品',
    'resource' => '平台资源',
    'self_product' => '自营商品',
    'self_resource' => '自营资源',
    'yuding' => '场地预定',
);

$identity = array
(
	1 => '个人',
	2 => '个体户',
	3 => '企业',
);

$status = array
(
    1 => '启用',
    2 => '禁用',
);

$account = function() {
    return Dever::load('account/api')->getConfig('scm_seller/info');
};

return array
(
	# 表名
	'name' => 'info',
	# 显示给用户看的名称
	'lang' => '经销商列表',
	# 是否显示在后台菜单
	'order' => 100,
    'check' => 'code',

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '经销商ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			//'list'		=> true,
			'order'		=> 'asc',
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '经销商名称',
			'default' 	=> '',
			'desc' 		=> '经销商名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
			'edit'		=> true,
		),

        'code'      => array
        (
            'type'      => 'varchar-150',
            'name'      => '经销商编码',
            'default'   => '',
            'desc'      => '经销商编码',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

		'info'      => array
        (
            'type'      => 'varchar-800',
            'name'      => '经销商介绍',
            'default'   => '',
            'desc'      => '经销商介绍',
            'match'     => 'option',
            'update'    => 'textarea',
        ),

		'type_id'        => array
        (
            'type'      => 'int-11',
            'name'      => '经销商类型',
            'default'   => '1',
            'desc'      => '经销商类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $type,
            //'list'		=> true,
        ),

        'scm_seller-shop'=> array
        (
            'name'      => '门店设置',
            'default'   => '',
            'desc'      => '门店设置',
            'match'     => 'option',
            # 同步更新另外一个表的内容，两个表相关联的id，更新另一个表的字段
            'sync'      => array('id', 'seller_id'),
            'update'    => array(1),
            # 1纵向展示 2横向展示
            'update_type' => 2,
            'list_name' => '门店列表',
            'list'      => 'Dever::load("scm_seller/lib/manage.getShop", {id})',
        ),

        'account'      => array
        (
            'type'      => 'varchar-800',
            'name'      => '资金账户-可以选择多个资金账户，账户余额可用于提现和分销',
            'default'   => '',
            'desc'      => '资金账户',
            'match'     => 'is_string',
            'update'    => 'checkbox',
            'option'    => $account,
            'tab'       => 1,
            //'list_name' => '账户信息',
            //'list'      => 'Dever::load("account/api.getInfo", {id}, "{account}")',
        ),

        'func'      => array
        (
            'type'      => 'varchar-2000',
            'name'      => '基础功能',
            'default'   => 'base',
            'desc'      => '基础功能',
            'match'     => 'is_string',
            'update'    => 'checkbox',
            'option'    => $func,
            'tab'       => 1,
            'control'   => 'func',
        ),

        'category'      => array
        (
            'type'      => 'varchar-2000',
            'name'      => '平台商品属性分类-如不选择就是可以销售所有商品属性分类下的商品',
            'default'   => '',
            'desc'      => '商品属性分类',
            'match'     => 'is_string',
            'update'    => 'checkbox',
            'option'    => $category,
            'tab'       => 1,
            'show'      => 'func=product',
        ),

        'price_id'       => array
        (
            'type'      => 'int-11',
            'name'      => '平台商品价格模板',
            'default'   => '-1',
            'desc'      => '平台商品价格模板',
            'match'     => 'is_numeric',
            'update'    => 'select',
            'option'    => $price,
            'tab'       => 1,
            'show'      => 'func=product',
        ),

        'commission'        => array
        (
            'type'      => 'varchar-20',
            'name'      => '销售佣金调整-针对每个商品的销售佣金做统一调整，如填写5%，就是在原有销售佣金的基础上增加5%佣金，设置为0则不做任何调整，设置为no，则佣金为0',
            'default'   => '0',
            'desc'      => '销售佣金调整',
            'match'     => 'option',
            'update'    => 'text',
            'tab'       => 1,
            'show'      => 'func=agent',
        ),

		'truename'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '联系人姓名',
            'default'   => '',
            'desc'      => '请输入联系人姓名',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'tab'		=> 2,
        ),

        'mobile'      => array
        (
            'type'      => 'bigint-11',
            'name'      => '联系人电话',
            'default'   => '',
            'desc'      => '请输入联系人电话',
            'match'     => 'is_numeric',
            'update'    => 'text',
            'search'    => 'fulltext',
            'tab'		=> 2,
        ),

        'area'       => array
        (
            'type'      => 'varchar-500',
            'name'      => '联系人所在区县',
            'default'   => '',
            'desc'      => '联系人所在区县',
            'match'     => 'option',
            'search'    => 'linkage',
            'update'    => 'linkage',
            'option'    => Dever::url('api.get?level_total=3', 'area'),
            //'list'      => 'Dever::load("area/api.string", "{area}")',
            'tab'		=> 2,
        ),

        'province'      => array
        (
            'type'      => 'int-11',
            'name'      => '省份',
            'default'   => '',
            'desc'      => '省份',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'       => 2,
        ),

        'city'      => array
        (
            'type'      => 'int-11',
            'name'      => '城市',
            'default'   => '',
            'desc'      => '城市',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'       => 2,
        ),

        'county'      => array
        (
            'type'      => 'int-11',
            'name'      => '县区',
            'default'   => '',
            'desc'      => '县区',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'       => 2,
        ),

        'address'       => array
        (
            'type'      => 'varchar-1000',
            'name'      => '联系人详细地址',
            'default'   => '',
            'desc'      => '联系人详细地址',
            'match'     => 'option',
            'update'    => 'text',
            //'list'        => true,
            'tab'		=> 2,
        ),

        'identity'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '经销商身份',
            'default'   => '1',
            'desc'      => '经销商身份',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $identity,
            'control'	=> 'identity',
            'tab'		=> 3,
        ),

        'idcard_front'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '身份证正面-如果是个人，这里上传联系人身份证，如果是个体户或者企业，这里上传法人身份证',
            'default'   => '',
            'desc'      => '身份证正面',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'tab'		=> 3,
        ),

        'idcard_back'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '身份证背面-如果是个人，这里上传联系人身份证，如果是个体户或者企业，这里上传法人身份证',
            'default'   => '',
            'desc'      => '身份证背面',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'tab'		=> 3,
        ),

        'company_license'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '营业执照',
            'default'   => '',
            'desc'      => '企业营业执照',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'show'		=> 'identity=2,3',
            'tab'		=> 3,
        ),

        'company_name'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '企业全称',
            'default'   => '',
            'desc'      => '企业全称',
            'match'     => 'option',
            //'update'    => 'text',
            'show'      => 'identity=2,3',
            'tab'       => 3,
        ),

        'company_number'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '社会信用代码',
            'default'   => '',
            'desc'      => '社会信用代码',
            'match'     => 'option',
            //'update'    => 'text',
            'show'      => 'identity=2,3',
            'tab'       => 3,
        ),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			//'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

        'status'        => array
        (
            'type'      => 'int-11',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '状态',
            'match'     => 'is_numeric',
            //'update'  => 'select',
            'option'    => $status,
            'search'    => 'select',
            'list'      => true,
            'edit'      => true,
        ),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'search'	=> 'date',
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
        'delete' => false,
		'tab' => array('基本设置', '功能设置', '联系人信息', '认证信息'),
		'button' => array
        (
            //'类型配置' => array('list', 'type&oper_parent=seller'),
        ),
        'list_button' => array
        (
            'br1' => array('<br />'),
            'location' => array('分配供应商', Dever::url('lib/set.home?role=seller', 'scm_supplier')),
            'location1' => array('分配配送商', Dever::url('lib/set.home?role=seller', 'scm_servicer')),
            'location2' => array('商品设置', Dever::url('lib/set.home?project=seller&table=goods&info=info', 'scm_product')),
            'add' => array('采购下单', 'buy_order&oper_table=info&search_option_seller_id={id}&oper_save_jump=buy_order'),
            'add1' => array('代客下单', 'buy_order&oper_table=info&search_option_seller_id={id}&oper_save_jump=buy_order'),
            'br4' => array('<br />'),
            'fast_add' => array('账户操作', 'push&project=account&oper_table=info&oper_project=scm_seller&uid={id}'),
            'list' => array('账户列表', 'info&project=account&oper_table=info&oper_project=scm_seller&search_option_uid={id}', '"{account}"'),
        )
	),

	'default' => array
	(
		'col' => 'name,code,type_id,state,cdate',
		'value' => array
		(
			'"平台经销商", "platform", 1, 1,' . DEVER_TIME,
		),
	),

	'request' => array
	(
		'like' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'name' => array('yes', 'like'),
                'id' => 'yes',
                'status' => 1,
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('reorder' => 'desc', 'id' => 'desc'),
            'col' => '*|id',
        ),
	)
);
