<?php


$stock = array
(
    1 => '独立库存',
    2 => '共享库存',
);
$shop = function()
{
	$array = array();
	$data = Dever::load('scm_seller/shop-state');
	if($data)
	{
		$array += $data;
	}
	return $array;
};

$type = array
(
	1 => '实体店',
	2 => '网店',
	3 => '虚拟店',
);

$status = array
(
	1 => '启用',
	2 => '禁用',
);

$set = Dever::input('set', 2);

return array
(
	# 表名
	'name' => 'shop',
	# 显示给用户看的名称
	'lang' => '经销商门店',
	# 是否显示在后台菜单
	'order' => 10,
	'menu' => false,
	'check' => 'seller_id,code',

	'status' => $status,

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'list'		=> true,
			'order'		=> 'asc',
		),

		'seller_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '经销商ID',
			'default' 	=> '-1',
			'desc' 		=> '经销商ID',
			'match' 	=> 'is_numeric',
			'update'	=> 'hidden',
			'value'		=> Dever::input('search_option_seller_id'),
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '门店名称',
			'default' 	=> '',
			'desc' 		=> '门店名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
			'edit'		=> true,
		),

		'code'      => array
        (
            'type'      => 'varchar-150',
            'name'      => '门店编码',
            'default'   => '',
            'desc'      => '门店编码',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'type'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '门店类型-实体店需要设置门店地址',
            'default'   => '2',
            'desc'      => '门店类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $type,
            'list'		=> true,
            'control'	=> 'type',
        ),

        'area'       => array
        (
            'type'      => 'varchar-500',
            'name'      => '所在区县',
            'default'   => '',
            'desc'      => '所在区县',
            'match'     => 'is_string',
            'search'    => 'linkage',
            'update'    => $set == 1 ? 'linkage' : false,
            'option'    => Dever::url('api.get?level_total=3', 'area'),
            //'list'      => 'Dever::load("area/api.string", "{area}")',
            'show'		=> 'type=1',
        ),

        'address'       => array
        (
            'type'      => 'varchar-1000',
            'name'      => '详细地址',
            'default'   => '',
            'desc'      => '详细地址',
            'match'     => 'is_string',
            'update'    => $set == 1 ? 'text' : false,
            'show'		=> 'type=1',
        ),

        'truename'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '联系人姓名',
            'default'   => '',
            'desc'      => '请输入联系人姓名',
            'match'     => 'is_string',
            'update'    => $set == 1 ? 'text' : false,
            'search'    => 'fulltext',
            'show'		=> 'type=1',
        ),

        'tel'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '联系人电话',
            'default'   => '',
            'desc'      => '请输入联系人电话',
            'match'     => 'is_numeric',
            'update'    => $set == 1 ? 'text' : false,
            'search'    => 'fulltext',
            'show'		=> 'type=1',
        ),

        'stock'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '库存设置-如果商品有库存，这里设置库存是否独立或共享，独立库存就是该门店自己使用一套库存，共享库存就是和其他门店共享一套库存，共享库存将无法设置商品',
            'default'   => '1',
            'desc'      => '库存设置',
            'match'     => 'is_numeric',
            'update'    => $set == 1 ? 'radio' : false,
            'option'    => $stock,
            'control'	=> 'stock',
            'tab'		=> 1,
        ),

        'stock_shop'        => array
        (
            'type'      => 'int-11',
            'name'      => '共享门店-选择和哪个门店共享一套库存',
            'default'   => '-1',
            'desc'      => '共享经销商',
            'match'     => 'is_numeric',
            'update'    => $set == 1 ? 'select' : false,
            'option'    => $shop,
            'show'		=> 'stock=2',
            'tab'		=> 1,
        ),

        'company_license'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '营业执照',
            'default'   => '',
            'desc'      => '企业营业执照',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'tab'		=> 2,
        ),

        'company_name'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '企业全称',
            'default'   => '',
            'desc'      => '企业全称',
            'match'     => 'option',
            'update'    => 'text',
            'tab'       => 2,
        ),

        'company_number'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '社会信用代码',
            'default'   => '',
            'desc'      => '社会信用代码',
            'match'     => 'option',
            'update'    => 'text',
            'tab'       => 2,
        ),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			//'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

		'status'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否启用',
			'default' 	=> '1',
			'desc' 		=> '是否启用',
			'match' 	=> 'is_numeric',
			'update'	=> 'radio',
			'option'	=> $status,
			'list'		=> true,
			'edit'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'search'	=> 'date',
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		'tab' => array('基本信息', '商品设置', '门店认证'),
		'delete' => false,
        
	),

	'request' => array
	(
		
	)
);
