<?php

$status = array
(
	1 => '启用',
	2 => '禁用',
);

$type = array
(
	1 => '实体仓',
	2 => '虚拟仓',
);

$set = Dever::input('set', 2);

return array
(
	# 表名
	'name' => 'store',
	# 显示给用户看的名称
	'lang' => '配送商仓库',
	# 是否显示在后台菜单
	'order' => 10,
	'menu' => false,

	'status' => $status,

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'list'		=> true,
			'order'		=> 'asc',
		),

		'servicer_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '配送商ID',
			'default' 	=> '-1',
			'desc' 		=> '配送商ID',
			'match' 	=> 'is_numeric',
			'update'	=> 'hidden',
			'value'		=> Dever::input('search_option_servicer_id'),
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '仓库名称',
			'default' 	=> '',
			'desc' 		=> '仓库名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
			'edit'		=> true,
		),

		'code'      => array
        (
            'type'      => 'varchar-150',
            'name'      => '仓库编码',
            'default'   => '',
            'desc'      => '仓库编码',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'type'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '门店类型-实体仓需要设置地址',
            'default'   => '2',
            'desc'      => '门店类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $type,
            'list'		=> true,
            'control'	=> 'type',
        ),

        'area'       => array
        (
            'type'      => 'varchar-500',
            'name'      => '所在区县',
            'default'   => '',
            'desc'      => '所在区县',
            'match'     => 'is_string',
            'search'    => 'linkage',
            'update'    => $set == 1 ? 'linkage' : false,
            'option'    => Dever::url('api.get?level_total=3', 'area'),
            //'list'      => 'Dever::load("area/api.string", "{area}")',
            'show'		=> 'type=1',
        ),

        'address'       => array
        (
            'type'      => 'varchar-1000',
            'name'      => '详细地址',
            'default'   => '',
            'desc'      => '详细地址',
            'match'     => 'is_string',
            'update'    => $set == 1 ? 'text' : false,
            'show'		=> 'type=1',
        ),

        'truename'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '联系人姓名',
            'default'   => '',
            'desc'      => '请输入联系人姓名',
            'match'     => 'is_string',
            'update'    => $set == 1 ? 'text' : false,
            'search'    => 'fulltext',
            'show'		=> 'type=1',
        ),

        'tel'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '联系人电话',
            'default'   => '',
            'desc'      => '请输入联系人电话',
            'match'     => 'is_numeric',
            'update'    => $set == 1 ? 'text' : false,
            'search'    => 'fulltext',
            'show'		=> 'type=1',
        ),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			//'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

		'status'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否启用',
			'default' 	=> '1',
			'desc' 		=> '是否启用',
			'match' 	=> 'is_numeric',
			'update'	=> 'radio',
			'option'	=> $status,
			'list'		=> true,
			'edit'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'search'	=> 'date',
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		'delete' => false,
        
	),

	'request' => array
	(
		
	)
);
