<?php

return array
(
    # 表名
    'name' => 'store_goods',
    # 显示给用户看的名称
    'lang' => '仓库商品列表',
    'order' => 10,
    'menu'  => false,

    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            //'list'        => true,
        ),

        'servicer_store_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '配送商仓库',
            'default'   => '',
            'desc'      => '配送商仓库',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'search'    => 'hidden',
            'value'     => Dever::input('search_option_servicer_store_id'),
            'list'      => 'Dever::load("scm_servicer/store-one#name", {servicer_store_id})',
        ),

        'scm_product-info_sku-code'=> array
        (
            'name'      => '商品编码',
            'default'   => '',
            'desc'      => '商品编码',
            'match'     => 'option',
            # 读取另外表的关联方式
            'sync'      => array('sku_id', 'id', 'goods_id', 'info_id', 'key'),
            'search'    => array
            (
                'api' => 'scm_product/info_sku-all',
                'col' => 'code',
                'result' => 'id',
                'search' => 'sku_id',
            ),
            'list'      => true,
        ),

        'goods_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '商品名称',
            'default'   => '',
            'desc'      => '商品名称',
            'match'     => 'is_numeric',
            'search'    => array
            (
                'api' => 'scm_product/info-all',
                'col' => 'name',
                'result' => 'id',
                'search' => 'goods_id',
            ),
            'update'    => 'select',
            'update_search' => 'scm_product/lib/manage.search',
            'list'      => 'Dever::load("scm_product/lib/info.getBaseInfo#aname", "{goods_id}", "{sku_id}")',
        ),

        'sku_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '规格型号',
            'default'   => '-1',
            'desc'      => '规格型号',
            'match'     => 'is_numeric',
        ),

        'unit_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '基本单位',
            'default'   => '',
            'desc'      => '基本单位',
            'match'     => 'is_numeric',
            'list'      => 'Dever::load("scm/unit-one#name", {unit_id})',
        ),

        'cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '入库均价',
            'default'   => '',
            'desc'      => '入库均价',
            'match'     => 'option',
            'list'      => true,
        ),

        'in_num'        => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '入库总库存',
            'default'   => '0',
            'desc'      => '入库总库存',
            'match'     => 'is_numeric',
            'list'      => true,
        ),

        'out_num'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '出库总库存',
            'default'   => '0',
            'desc'      => '出库总库存',
            'match'     => 'option',
            'list'      => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            //'search'    => 'date',
            //'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        'insert' => false,
        'edit' => false,
        'delete' => false,
        'list_button' => array
        (
            'list' => array('查看详情', '"store_goods_list&oper_table=store_goods&top_table=info&search_option_store_goods_id={id}"'),
        ),
    ),

    'request' => array
    (
        # 后台搜索用到，也可以不加，自动生成
        'search' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'name' => array('yes-t_2.name', 'like'),
                'servicer_store_id' => array('yes-t_1.servicer_store_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'scm_product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*, t_2.*,t_2.id as value, "" as selected, "" as disabled',
        ),

        'getData' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'servicer_store_id' => array('yes-t_1.servicer_store_id'),
                'sell_type' => array('yes-t_2.sell_type'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'scm_product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'col' => 'id,name,category,pic,content,video,type,unit,spec_type,goods,commission,pay_money,money_id,score_id,sell_type,buy_type,udate,cdate',
        ),

        'getDataPage' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'servicer_store_id' => array('yes-t_1.servicer_store_id'),
                'sell_type' => array('yes-t_2.sell_type'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'scm_product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => 'id,name,category,pic,content,video,type,unit,spec_type,goods,commission,pay_money,money_id,score_id,sell_type,buy_type,udate,t_1.cdate,t_1.id as id',
        ),

        # 获取某个sku的单条数据
        'getOne' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'servicer_store_id' => 'yes',
                'goods_id' => 'yes',
                'sku_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'one',
            'col' => '*,(sum(in_num)-sum(out_num)) as total,AVG(cash) as cash',
        ),

        # 获取单位下的数据
        'getUnit' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'servicer_store_id' => 'yes',
                'goods_id' => 'yes',
                'sku_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'col' => '*,(in_num-out_num) as total|unit_id',
        ),
    ),
);
